# ola-ui-jd

ola-ui 的 jd 业务组件层。

## Install

```bash
yarn add ola-ui-jd
```

## DEV

```bash
yarn build  ## 打包

yarn dev  ## 打包 (watch 模式)
  ```

## Quick Start

添加 reducer

```javascript
import {combineReducers} from 'redux-immutable';
import {reducers as olaReducers} from 'ola-ui-jd';

export default combineReducers({
  
  // ...,

  olaReducers,

  // ...,
});
```

添加 saga

```javascript
import {all, fork} from 'redux-saga/effects';
import {sagas as olaSagas} from 'ola-ui-jd';
import createSagaMiddleware from 'redux-saga';

export function* initSagas() {
  yield all([
    // ...,
    fork(olaSagas),
    // ...,
  ]);
}

// run saga middleware with sagas
const sagaMiddleware = createSagaMiddleware();
sagaMiddleware.run(initSagas);
```

调用组件

```javascript
import React, {Component} from 'react';
import {SomeComponent} from 'ola-ui-jd';

export default class MyComponent extends Component {

  render() {
    return <SomeComponent />;
  }

}
```
