'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = dataSource;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _VisibilitySensor = require('ola-ui/lib/components/VisibilitySensor');

var _VisibilitySensor2 = _interopRequireDefault(_VisibilitySensor);

var _olaToolkit = require('ola-toolkit');

var _Exception = require('../Exception');

var _Exception2 = _interopRequireDefault(_Exception);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

/**
 * 可配置数据源的组件
 * @param prop 自定义数据存储在 state 中的 key
 * @returns {Component}
 */
function dataSource(_ref) {
  var _ref$prop = _ref.prop,
      prop = _ref$prop === undefined ? 'data' : _ref$prop;


  return function DataSourceComponentFactory(WrappedComponent) {
    var _desc, _value, _class, _class2, _temp2;

    return _class = (_temp2 = _class2 = function (_WrappedComponent) {
      (0, _inherits3.default)(HOC, _WrappedComponent);

      function HOC() {
        var _ref2;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, HOC);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = HOC.__proto__ || (0, _getPrototypeOf2.default)(HOC)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
          dataSourceBusy: false,
          dataSourceError: null

        }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
      }

      (0, _createClass3.default)(HOC, [{
        key: 'fetchData',


        /**
         * 数据请求
         * @param extraData
         */
        value: function fetchData() {
          var _this2 = this;

          var extraData = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
          var _props = this.props,
              dataSource = _props.dataSource,
              dataSourceHttpMethod = _props.dataSourceHttpMethod,
              dataSourceReqProcessor = _props.dataSourceReqProcessor,
              dataSourceRspProcessor = _props.dataSourceRspProcessor,
              _props$dataSourceValu = _props.dataSourceValues,
              dataSourceValues = _props$dataSourceValu === undefined ? {} : _props$dataSourceValu,
              dataSourceFetchOptions = _props.dataSourceFetchOptions;
          var dataSourceBusy = this.state.dataSourceBusy;


          if (!dataSource || dataSourceBusy || this.unmounted) return;

          var data = this.getFilter();

          data = (0, _assign2.default)(dataSourceValues, data, extraData);

          data = dataSourceReqProcessor(data);

          if (data === false) {
            return;
          }

          this.setState({
            dataSourceBusy: true,
            dataSourceError: null
          });

          var finalDataSourceFetchOptions = (0, _extends4.default)((0, _defineProperty3.default)({
            url: dataSource,
            turnoffAdaptor: true
          }, dataSourceHttpMethod === 'GET' ? 'params' : 'data', data), dataSourceFetchOptions);

          _olaToolkit.Ajax[dataSourceHttpMethod.toLowerCase()](finalDataSourceFetchOptions).then(function (rsp) {
            if (_this2.unmounted) {
              return;
            }
            rsp = _immutable2.default.fromJS(rsp);
            var data = rsp;
            if (data) {
              var _this2$setState;

              data = dataSourceRspProcessor(data, rsp);
              _this2.setState((_this2$setState = {}, (0, _defineProperty3.default)(_this2$setState, prop, data), (0, _defineProperty3.default)(_this2$setState, 'dataSourceBusy', false), _this2$setState));
            } else {
              var _this2$setState2;

              _this2.setState((_this2$setState2 = {}, (0, _defineProperty3.default)(_this2$setState2, prop, null), (0, _defineProperty3.default)(_this2$setState2, 'dataSourceBusy', false), _this2$setState2));
            }
          }, function (err) {
            if (_this2.unmounted) {
              return;
            }
            _this2.setState({
              dataSourceBusy: false,
              dataSourceError: err
            });
          });
        }

        /**
         *  filterForms 中获取过滤条件
         * @returns {{}}
         */

      }, {
        key: 'getFilter',
        value: function getFilter() {
          return {};
          // let {filterForms} = this.props;
          // let filter = {};
          // filterForms.forEach((filterForm) => {
          //   let {id: formId} = filterForm;
          //   let data = $(`#${formId}`).serializeObject();
          //   filter = $.extend(filter, data);
          // });
          // return filter;
        }

        /**
         * 更新数据
         * @param newData
         */

      }, {
        key: 'updateData',
        value: function updateData(newData) {
          this.setState((0, _defineProperty3.default)({}, prop, newData));
        }

        /**
         * dataSourceBusy
         * @param dataSourceBusy
         */

      }, {
        key: 'setDataSourceBusy',
        value: function setDataSourceBusy(dataSourceBusy) {
          this.setState({
            dataSourceBusy: dataSourceBusy
          });
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          (0, _get3.default)(HOC.prototype.__proto__ || (0, _getPrototypeOf2.default)(HOC.prototype), 'componentWillUnmount', this) && (0, _get3.default)(HOC.prototype.__proto__ || (0, _getPrototypeOf2.default)(HOC.prototype), 'componentWillUnmount', this).call(this);
          this.unmounted = true;
        }
      }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
          (0, _get3.default)(HOC.prototype.__proto__ || (0, _getPrototypeOf2.default)(HOC.prototype), 'componentDidMount', this) && (0, _get3.default)(HOC.prototype.__proto__ || (0, _getPrototypeOf2.default)(HOC.prototype), 'componentDidMount', this).call(this);

          var _props2 = this.props,
              filterForms = _props2.filterForms,
              dataSourceFetchTiming = _props2.dataSourceFetchTiming;

          // if (filterForms) {
          //   filterForms.forEach((filterForm, index) => {
          //
          //     /**
          //      * trigger 触发
          //      * id form id
          //      * @type {string}
          //      */
          //     let {trigger = 'submit', id: formId} = filterForm;
          //
          //     let $filterForm = $(`#${formId}`);
          //
          //     if (trigger) {
          //       $filterForm.bind(trigger, (e) => {
          //         let {target} = e;
          //         if (target.hasAttribute('trigger-ignore')) {
          //           return;
          //         }
          //
          //         e.preventDefault();
          //         if (!this.inVisible) {
          //           this.fetchData();
          //         } else {
          //           this.needUpdate = true;
          //         }
          //       });
          //     }
          //   });
          // }

          if (dataSourceFetchTiming === 'init') {
            this.fetchData();
          }
        }
      }, {
        key: 'getActualDom',
        value: function getActualDom() {
          var _state = this.state,
              dataSourceError = _state.dataSourceError,
              dataSourceBusy = _state.dataSourceBusy;

          var data = this.state[prop];

          // if (dataSourceError) {
          //   return this.renderDataSourceError(dataSourceError);
          // }

          // let rendered = super.render();
          // console.log(rendered)


          // if (this.renderDataSourceBusy) {
          //   loading = this.renderDataSourceBusy();
          // }

          var props = (0, _defineProperty3.default)({}, prop, {
            payload: data || _immutable2.default.Map(),
            loading: dataSourceBusy,
            error: dataSourceError,
            fetch: this.fetchData,
            update: this.fetchData
          });

          // return <Loading overlayOpacity={.1} busy={Boolean(data && dataSourceBusy)} type={'joy'} text={'...加载中...'} style={{}}>
          //   {<WrappedComponent {...props}/>}
          //   {Boolean(!data && dataSourceBusy) && <Loading type={'joy'} text={'...加载中...'}/>}
          // </Loading>
          return _react2.default.createElement(WrappedComponent, props);
        }
      }, {
        key: 'renderDataSourceError',
        value: function renderDataSourceError(dataSourceError) {
          if ((0, _get3.default)(HOC.prototype.__proto__ || (0, _getPrototypeOf2.default)(HOC.prototype), 'renderDataSourceError', this)) {
            var rendered = (0, _get3.default)(HOC.prototype.__proto__ || (0, _getPrototypeOf2.default)(HOC.prototype), 'renderDataSourceError', this).call(this, dataSourceError);
            if (rendered) {
              return rendered;
            }
          }
          return _react2.default.createElement(_Exception2.default, { type: 'error', text: dataSourceError.message });
        }
      }, {
        key: 'render',
        value: function render() {
          var _this3 = this;

          var dataSourceFetchTiming = this.props.dataSourceFetchTiming;

          if (dataSourceFetchTiming !== 'auto') {
            return this.getActualDom();
          }

          var _state2 = this.state,
              dataSourceError = _state2.dataSourceError,
              dataSourceBusy = _state2.dataSourceBusy;

          var data = this.state[prop];

          return _react2.default.createElement(
            _VisibilitySensor2.default,
            {
              partialVisibility: true,
              onChange: function onChange(isVisible) {

                if (_this3.onVisibilityChange) {
                  if (isVisible === _this3.inVisible) {
                    _this3.onVisibilityChange.call(_this3, isVisible);
                  }
                }

                _this3.inVisible = !isVisible;

                if (!_this3.inVisible) {
                  if (data === undefined && !dataSourceBusy && !dataSourceError || _this3.needUpdate) {
                    _this3.needUpdate = false;
                    _this3.fetchData();
                  }
                }
              }
            },
            this.getActualDom()
          );
        }
      }]);
      return HOC;
    }(WrappedComponent), _class2.propTypes = (0, _assign2.default)({}, {

      // 数据源
      dataSource: _propTypes2.default.string,

      // ajax option
      dataSourceFetchOptions: _propTypes2.default.object,

      // 是否初始化后获取数据
      dataSourceFetchTiming: _propTypes2.default.oneOf(['manual', 'auto', 'init']),

      // 数据请求处理函数
      dataSourceReqProcessor: _propTypes2.default.func,

      // 数据响应处理函数
      dataSourceRspProcessor: _propTypes2.default.func,

      // 预定义数据，与 form 合并
      dataSourceValues: _propTypes2.default.object,

      // 是否初始化后获取数据
      dataSourceHttpMethod: _propTypes2.default.oneOf(['GET', 'POST'])

      // 过滤器表单配置
      // filterForms: PropTypes.array,

    }, WrappedComponent.propTypes), _class2.defaultProps = (0, _assign2.default)({}, {
      // filterForms: [],
      dataSourceFetchOptions: {},
      dataSourceHttpMethod: 'GET',
      dataSourceFetchTiming: 'auto',
      dataSourceRspProcessor: function dataSourceRspProcessor(data) {
        return data;
      },
      dataSourceReqProcessor: function dataSourceReqProcessor(data) {
        return data;
      }
    }, WrappedComponent.defaultProps), _temp2), (_applyDecoratedDescriptor(_class.prototype, 'fetchData', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'fetchData'), _class.prototype)), _class;
  };
}
module.exports = exports['default'];