# ErpSelector

通过 erp 查询并选择用户

## 示例

  <demo src="basic.jsx" title="基础用法"></demo>

  <demo src="max.jsx" title="max"></demo>

  <demo src="value.jsx" title="已选的 (value)"></demo>
  
## 服务端

### 配置

properties

```properties
user.info.appCode=001
user.info.businessId=002
user.info.safetyKey=abc123
```

创建自定义 bean `(optional)`

```xml
<bean id="myErpUserService" class="com.jd.ola.biz.service.erp.impl.ErpUserServiceImpl">
   <property name="param" value="someValue"/>
</bean>
```

或使用预定义 bean: `erpUserService`
  
## API

### USER

```javascript
{
  erp: string,
  name: string,
  avatar: string,
  organization: string,
  
  fixed: bool,  // 固定、不可删除的
}
```

| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| value | value | User[] | - |
| onChange | user 变化回调 | function(User[]) | - |
| max | 可添加的最大个数 | number | 3 |
| size | 尺寸 | 'small' 'default' 'large'| default |
| onSuggestionsFetchRequested | 请求接口调用回调 | function(input) | - |
| onSuggestionClearRequested | 清除输入建议框回调 | function() | - |
| suggestionList | 查询结果 | User[] | [] |
| busy | bool | 请求中状态 (loading) | false |
| inputPlaceholder | string | input placeholder | '' |


