import React, {Component} from 'react';
import {ErpSelector} from 'ola-ui-jd';
import {bind} from 'ola-toolkit';

export default class MaxDemo extends Component {

  static propTypes = {};

  state = {
    value: [],
    busy: false,
    suggestionList: []
  };

  @bind
  onSuggestionsFetchRequested(keyword) {
    setTimeout(() => {
      this.setState({
        busy: false,
        suggestionList: Array(5).fill().map((i, index) => ({
          erp: `erp${index}`,
          name: `name${index}`,
          avatar: `https://storage.jd.com/ola-ui/img/defaultAvatar.png`,
          organization: '成都研究院-网站业务部'
        }))
      });
    }, 300);

    this.setState({
      busy: true,
    });
  }

  render() {
    const {suggestionList, busy} = this.state;

    return <div>
      <ErpSelector
        value={this.state.value}
        max={2}
        onSuggestionsFetchRequested={this.onSuggestionsFetchRequested}
        onSuggestionClearRequested={() => {
          this.setState({
            busy: false,
            suggestionList: [],
          });
        }}
        suggestionList={suggestionList}
        busy={busy}
        onChange={(value) => {
          console.log('change', value === this.state.value, value);
          this.setState({
            value,
            suggestionList: []
          })
        }}
      />
    </div>
  }
}
