# ErrorBoundary

React 16 ErrorBoundary 的业务工程通用实现

ErrorBoundary 避免了未捕获的内部异常导致应用显示空白页，它捕获子组件树中的异常，并提供了一个通用的 fallback UI.

ErrorBoundary 在异常出现的时候会友好地反馈用户，并提供异常信息上报的功能，目前预定义的异常上报功能仅支持发送带有异常信息的邮件，自有实现请使用 `onReport`.

如果需要完全定制 fallback UI，请使用 `renderer`

## 示例

  <demo src="basic.jsx" title="子组件中的异常模拟"></demo>

## API

| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| className | className | string | '' |
| style | style | object | {padding: '8% 0'} |
| onReport | 异常上报回调 | function({url, userAgent, msg, stack, componentStack}) | mailto |
| reportMailTo | 默认异常上报回调中的收件人 | string | - |
| renderer | 自定义 render | function(error, info) | - |
