"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp2;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _Button = require("ola-ui/lib/components/Button");

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require("ola-ui/lib/components/Icon");

var _Icon2 = _interopRequireDefault(_Icon);

var _Collapse = require("ola-ui/lib/components/Collapse");

var _Collapse2 = _interopRequireDefault(_Collapse);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Panel = _Collapse2.default.Panel;

var ErrorBoundary = (_temp2 = _class = function (_Component) {
  (0, _inherits3.default)(ErrorBoundary, _Component);

  function ErrorBoundary() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ErrorBoundary);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ErrorBoundary.__proto__ || (0, _getPrototypeOf2.default)(ErrorBoundary)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      hasError: false,
      error: {}
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ErrorBoundary, [{
    key: "componentDidCatch",
    value: function componentDidCatch(error, info) {
      this.setState({
        hasError: true,
        error: error, info: info
      });
    }
  }, {
    key: "render",
    value: function render() {
      var styles = require('./style.less');
      var _state = this.state,
          hasError = _state.hasError,
          error = _state.error,
          info = _state.info;
      var _props = this.props,
          onReport = _props.onReport,
          reportMailTo = _props.reportMailTo,
          className = _props.className,
          style = _props.style,
          renderer = _props.renderer;


      if (hasError) {
        if (renderer) {
          return renderer(error, info);
        }
        return _react2.default.createElement(
          "div",
          { className: styles.container + " " + className, style: style },
          _react2.default.createElement(
            "h2",
            { className: styles.header },
            _react2.default.createElement(_Icon2.default, { className: styles.icon, type: "close-circle-o" }),
            " \u62B1\u6B49\uFF0C\u5E94\u7528\u51FA\u73B0\u4E86\u5F02\u5E38"
          ),
          _react2.default.createElement(
            _Collapse2.default,
            null,
            _react2.default.createElement(
              Panel,
              { header: _react2.default.createElement(
                  "div",
                  { className: styles.panelHeader },
                  _react2.default.createElement(_Icon2.default, { type: 'warning' }),
                  " ",
                  error.message
                ) },
              _react2.default.createElement(
                "pre",
                { className: styles.pre },
                error && error.stack && _react2.default.createElement(
                  _react2.default.Fragment,
                  null,
                  _react2.default.createElement(
                    "h5",
                    null,
                    "call stack:"
                  ),
                  _react2.default.createElement(
                    "code",
                    null,
                    error.stack.replace(/^\n/, '')
                  )
                ),
                info && info.componentStack && _react2.default.createElement(
                  _react2.default.Fragment,
                  null,
                  _react2.default.createElement(
                    "h5",
                    null,
                    "component stack:"
                  ),
                  _react2.default.createElement(
                    "code",
                    null,
                    info.componentStack.replace(/^\n/, '')
                  )
                )
              )
            )
          ),
          _react2.default.createElement(
            "div",
            { className: styles.actions },
            _react2.default.createElement(
              _Button2.default,
              { type: 'primary', onClick: function onClick() {
                  location.reload();
                } },
              "\u5237\u65B0\u8BD5\u8BD5"
            ),
            _react2.default.createElement(
              _Button2.default,
              { type: 'secondary', onClick: function onClick() {
                  onReport({
                    msg: error.message,
                    stack: error.stack,
                    componentStack: info.componentStack,
                    url: location.href,
                    userAgent: navigator.userAgent
                  }, reportMailTo);
                }
              },
              "\u4E0A\u62A5\u9519\u8BEF"
            )
          )
        );
      }
      return this.props.children;
    }
  }], [{
    key: "getDerivedStateFromError",
    value: function getDerivedStateFromError(error) {
      return {
        hasError: true,
        error: error
      };
    }
  }]);
  return ErrorBoundary;
}(_react.Component), _class.propTypes = {
  onReport: _propTypes2.default.func,
  reportMailTo: _propTypes2.default.string,
  className: _propTypes2.default.string,
  style: _propTypes2.default.object,
  renderer: _propTypes2.default.func
}, _class.defaultProps = {
  onReport: function onReport(_ref2) {
    var url = _ref2.url,
        userAgent = _ref2.userAgent,
        msg = _ref2.msg,
        stack = _ref2.stack,
        componentStack = _ref2.componentStack;
    var to = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

    location.href = "mailto:" + to + "?subject=\u524D\u7AEF\u5F02\u5E38\u4E0A\u62A5: " + location.hostname + "&body=" + msg + "%0A%0A\n            " + stack + "%0A%0A" + componentStack + "%0A%0Aurl: " + url + "%0A%0Aua: " + userAgent;
  },
  className: '',
  style: {}
}, _temp2);
exports.default = ErrorBoundary;
module.exports = exports["default"];