'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Exception (出错、空、普通提示)
 * @class
 *
 */
var Exception = (_temp = _class = function (_PureComponent) {
  (0, _inherits3.default)(Exception, _PureComponent);

  function Exception(props) {
    (0, _classCallCheck3.default)(this, Exception);
    return (0, _possibleConstructorReturn3.default)(this, (Exception.__proto__ || (0, _getPrototypeOf2.default)(Exception)).call(this, props));
  }

  (0, _createClass3.default)(Exception, [{
    key: 'render',
    value: function render() {
      var styles = require('./style.less');
      var _props = this.props,
          style = _props.style,
          type = _props.type,
          text = _props.text,
          gutter = _props.gutter,
          direction = _props.direction;


      if (text === undefined) {
        if (type === 'empty') {
          text = '暂时没有查询到相关内容';
        } else if (type === 'error') {
          text = 'oops, 这里出现了一些错误';
        }
      }

      var suffix = type === '404' ? 'png' : 'svg';

      var typeImg = require('./img/' + type + '.' + suffix);

      var gutterStyle = direction === 'vertical' ? {
        width: '100%',
        height: gutter
      } : {
        width: gutter,
        height: '100%'
      };

      return _react2.default.createElement(
        'div',
        { className: styles.container + ' ' + (direction === 'vertical' ? styles.vertical : '') + ' ',
          style: (0, _assign2.default)({ padding: '8% 0' }, style) },
        _react2.default.createElement('img', { src: typeImg, className: styles.img }),
        _react2.default.createElement('div', { style: gutterStyle }),
        _react2.default.createElement(
          'div',
          { className: '' + styles.text },
          text
        )
      );
    }
  }]);
  return Exception;
}(_react.PureComponent), _class.propTypes = {

  className: _propTypes2.default.string,

  style: _propTypes2.default.object,

  // 异常类型
  type: _propTypes2.default.oneOf(['empty', 'error', 'info', '404']).isRequired,

  // 文案
  text: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

  direction: _propTypes2.default.oneOf(['vertical', 'horizontal']),

  gutter: _propTypes2.default.number
}, _class.defaultProps = {
  className: '',

  style: {},

  gutter: 20,

  direction: 'vertical'
}, _temp);
exports.default = Exception;
module.exports = exports['default'];