# FillPrice

传入一组sku信息，自动对每一个子项进行价格填充，并传递给子组件。

## 示例

  <demo src="index.jsx" title="基础用法"></demo>

## 强制约定
```javascript
// 传入的sku列表
[
  {skuId: skuId, ....} // 每个子项，必需有一个skuId属性。
  ...
]

```

## API
| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| list | 一组SKU信息列表,每个子项必需包含skuId | array | [] |
| dataKey | 子组件接收lsit的prop名称，用于子组件渲染sku列表信息 | boolean | false |


## 子组件props
| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| loading | 价格加载状态 | boolean | false |
| errorMsg | 加载失败提示文案  | string | '' |

该组props会默认注入到子组件中，不需要显式书写，不可被更改，直接调用即可。
