'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

exports.getJfsImageUrl = getJfsImageUrl;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 图片服务器业务代号
 */
var IMG_ONLINE_BUSINESS_CODE = 'ola';

/**
 * 图片服务器业务测试代号
 */
var IMG_TEST_BUSINESS_CODE = 'test';

var IMG_BUSINESS_CODE = process.env.NODE_ENV === "production" ? IMG_ONLINE_BUSINESS_CODE : IMG_TEST_BUSINESS_CODE;

function getJfsImageUrl(_ref) {
  var _ref$index = _ref.index,
      index = _ref$index === undefined ? 3 : _ref$index,
      src = _ref.src,
      size = _ref.size,
      _ref$space = _ref.space,
      space = _ref$space === undefined ? IMG_BUSINESS_CODE : _ref$space;


  // index = Math.round(Math.random() * 5)

  var serverIndex = index % 5;
  size = size ? size + '/' : '';

  if (size) {
    src = '//img1' + serverIndex + '.360buyimg.com/' + size + src;
  } else {
    src = '//img1' + serverIndex + '.360buyimg.com/' + space + '/' + src;
  }

  return src;
}

var JfsImage = (_temp = _class = function (_PureComponent) {
  (0, _inherits3.default)(JfsImage, _PureComponent);

  function JfsImage(props) {
    (0, _classCallCheck3.default)(this, JfsImage);
    return (0, _possibleConstructorReturn3.default)(this, (JfsImage.__proto__ || (0, _getPrototypeOf2.default)(JfsImage)).call(this, props));
  }

  (0, _createClass3.default)(JfsImage, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          src = _props.src,
          index = _props.index,
          size = _props.size,
          alt = _props.alt,
          className = _props.className,
          width = _props.width,
          height = _props.height,
          style = _props.style,
          space = _props.space;

      var serverIndex = index % 5;

      src = getJfsImageUrl({
        index: serverIndex,
        src: src,
        size: size,
        space: space
      });

      var sizeProps = {};
      if (width) {
        sizeProps.width = width;
      }
      if (height) {
        sizeProps.height = height;
      }

      return _react2.default.createElement('img', (0, _extends3.default)({ style: style, src: src, alt: alt, className: className }, sizeProps));
    }
  }]);
  return JfsImage;
}(_react.PureComponent), _class.propTypes = {
  src: _propTypes2.default.string,
  index: _propTypes2.default.number,
  space: _propTypes2.default.string,
  size: _propTypes2.default.string,
  alt: _propTypes2.default.string,
  className: _propTypes2.default.string,
  width: _propTypes2.default.number,
  height: _propTypes2.default.number,
  style: _propTypes2.default.object
}, _class.defaultProps = {
  index: 3,
  alt: 'image',
  className: '',
  space: 'test',
  style: {}
}, _temp);
exports.default = JfsImage;