import React, {Component} from 'react';
import {Loading} from 'ola-ui-jd';
import {Switch, Slider, Select, Form, List} from 'ola-ui';

export default class Demo extends Component {

  static propTypes = {};

  state = {
    busy: true,
    overlayOpacity: 0.1,
    type: 'spin',
  };

  render() {

    const {busy, overlayOpacity, type} = this.state;

    return <div>
      <Loading type={type} busy={busy} overlayOpacity={overlayOpacity} text={'...加载中...'}>
        <List
          bordered={true}
          dataSource={Array(10).fill().map((x, index) => {
            return index;
          })}
          renderItem={item => (<List.Item>Item - {item}</List.Item>)}
        />
      </Loading>

      <br/>

      <Form layout={'inline'}>
        <Form.Item label={'busy'}>
          <Switch checked={busy} onChange={busy => this.setState({busy})} checkedChildren="true"
                  unCheckedChildren="false"/>
        </Form.Item>
        <Form.Item label={'type'}>
          <Select value={type} onChange={type => this.setState({type})}>
            <Select.Option value={'spin'}>spin</Select.Option>
            <Select.Option value={'joy'}>joy</Select.Option>
            <Select.Option value={'logo'}>logo</Select.Option>
          </Select>
        </Form.Item>
        <Form.Item label={'overlayOpacity'}>
          <Slider value={overlayOpacity} style={{width: 150}} max={1} min={0} step={.1}
                  onChange={overlayOpacity => this.setState({overlayOpacity})}/>
        </Form.Item>
      </Form>
    </div>
  }
}
