import React, {Component} from 'react';
import {OlaHeader} from "ola-ui-jd";
import {Icon, Menu, Switch} from "ola-ui";
import {bind} from "ola-toolkit";

const style = {margin: '10px 0 40px'};
const SubMenu = Menu.SubMenu;

export default class Demo extends Component {

  state = {
    current: 'mail',
    theme: 'dark',
  };

  @bind
  handleClick(e) {
    this.setState({
      current: e.key,
    });
  }

  render() {

    const {theme, current} = this.state;

    return <div>
      <Switch checkedChildren="light" unCheckedChildren="dark" checked={theme === 'light'} onChange={checked => {
        this.setState({theme: checked ? 'light' : 'dark'})
      }}/><br/><br/>

      <OlaHeader
        app={'huike'}
        title={'慧选 --- 智能选品'}
        theme={theme}
        showHomeLink={theme === 'light'}
        style={style}
        left={<div style={{paddingLeft: 10}}>Custom Left</div>}
        center={<div style={{display: 'flex', justifyContent: 'center'}}>
          <Menu
            theme={theme}
            onClick={this.handleClick}
            selectedKeys={[current]}
            style={{borderBottom: 0}}
            mode="horizontal"
          >
            <Menu.Item key="1">
              <Icon type="mail"/>导航一
            </Menu.Item>
            <SubMenu key="3" title={<span><Icon type="setting"/>导航二</span>}>
              <Menu.Item key="3:1">Option 1</Menu.Item>
              <Menu.Item key="3:2">Option 2</Menu.Item>
              <Menu.Item key="3:3">Option 3</Menu.Item>
              <Menu.Item key="3:4">Option 4</Menu.Item>
            </SubMenu>
          </Menu>
        </div>}
        right={<div style={{paddingRight: 10}}>Custom Right <Icon type={'setting'}/></div>}
        userName={'bjadmin'}
      />
    </div>;
  }

}
