# SimpleUploader

基于Uploader，二次封装的上传组件，降低了上传组件使用复杂度。

## 示例
<demo src="Basic.jsx" title="基础用法"></demo>

<demo src="Img.jsx" title="上传图片"></demo>

## 接口返回数据
```javascript
// 数据结构遵循AJAX组件规范
{
  success: boolen, // 成功或失败标签，同AJAX组件
  data: {
    name: string, // 若要替换文件显示名称，可以返回该值。默认文件名
    url: url // 若要点击查看文件，可以返回该值。默认无
  }
}
```

## API
| 参数        | 说明                                                                                                                                      | 类型                             | 默认值   |
|-------------|-------------------------------------------------------------------------------------------------------------------------------------------|----------------------------------|----------|
| URL         | 接口地址                                                                                                                                  | string[必填]                     | 无       |
| className   | className                                                                                                                                 | string                           | 无       |
| fileKey   | 替换上传文件key值                                                                                                                                 | string                           | file       |
| data   | 上传所需参数或返回上传参数的方法	                                                                                                                                 | object                           | 无       |
| showTips   | 是否显示格式提示                                                                                                                                 | boolean                           | true       |
| max         | 最大上传数                                                                                                                                | int                              | 1        |
| maxSize         | 文件最大上传体积，单位KB                                                                                                                                | int                              | 无限制        |
| triggerText | 触发元素上的文字                                                                                                                          | string                           | 导入文件 |
| triggerIcon | 触发元素上的图标，填入Icon组件type值                                                                                                      | string                           | upload   |
| accept      | 允许上传的文件格式，大小写不敏感。                                                                                                        | array                            | ['txt']  |
| listType    | 同Uploader，上传列表的内建样式，支持三种基本样式 `text`, `picture` 和 `picture-card`                                                                                                                                | string                           | 无       |
| onChange    | 文件列表状态发生变化时调用; 回传了`fileList`(变化后的文件列表)，`prevFileList`(变化前的文件列表)，`status`(变化状态 `uploading`,`error`,`done`,`error`) | fn(fileList,prevFileList,status) | 无       |
| onSuccess   | 文件上传成功后的回调                                                                                                                      | fn(file,fileList)                | 无       |
| onError     | 文件上传失败后的回调                                                                                                                      | fn(file,fileList)                | 无       |
| onRemove    | 文件删除后的回调                                                                                                                          | fn(file,fileList)                | 无       |
| onUploading | 文件上传中的回调                                                                                                                          | fn(fileList)                     | 无       |
