'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp; /*
                   * Author: cdzhongpeizi@jd.com
                   * Desc: 上传模块
                   * Props:
                   *   @url: url, 必填
                   *   @data: object, 非必填，
                   *   @fileKey: string, 非必填，默认值file
                   *   @className: string, 非必填
                   *   @showTips: boolean, 默认true
                   *   @max: int, 非必填  默认值1
                   *   @maxSize: int, 非必填 无
                   *   @triggerText: String, 非必填 默认:导入文件。
                   *   @triggerIcon: String, 非必填 默认:upload
                   *   @accept: Array, 非必填 允许上传的文件格式，大小写不敏感。 默认:['txt']
                   *   @listType: String, 同ola-ui uploader
                   *   @onChange: fn(fileList,prevFileList,status), 大部分时间使用onChange更新组件状态。
                   *   需要特殊处理时，使用下方钩子函数处理。 status:uploading||error||done||error
                   *
                   *   @onSuccess: fn(file,fileList), 非必填 成功回调
                   *   @onError: fn(file,fileList), 非必填 出错回调
                   *   @onUploading: fn(fileList), 非必填 上传中回调
                   *   @onRemove: fn(file,fileList), 非必填 删除回调
                   *
                   */

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Upload = require('ola-ui/lib/components/Upload');

var _Upload2 = _interopRequireDefault(_Upload);

var _Button = require('ola-ui/lib/components/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require('ola-ui/lib/components/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _uploaderProps = require('./uploaderProps');

var _uploaderProps2 = _interopRequireDefault(_uploaderProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SimpleUploader = (_temp = _class = function (_PureComponent) {
  (0, _inherits3.default)(SimpleUploader, _PureComponent);

  function SimpleUploader(props) {
    (0, _classCallCheck3.default)(this, SimpleUploader);

    var _this = (0, _possibleConstructorReturn3.default)(this, (SimpleUploader.__proto__ || (0, _getPrototypeOf2.default)(SimpleUploader)).call(this, props));

    _this.state = {
      loading: false
    };
    return _this;
  }

  (0, _createClass3.default)(SimpleUploader, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var loading = this.state.loading;


      var props = (0, _extends3.default)({
        loading: loading,
        data: {},
        fileKey: 'file',
        showTips: true,
        accept: ['txt'],
        triggerIcon: 'upload',
        triggerText: '导入文件'
      }, this.props);

      // 统一文件格式大小写
      props.accept = props.accept.map(function (item) {
        return item.toLocaleLowerCase();
      });

      props.beforeSend = function () {
        _this2.setState({ loading: true });
      };

      props.complete = function () {
        _this2.setState({ loading: false });
      };

      var uploadProps = (0, _uploaderProps2.default)((0, _extends3.default)({}, props)).props;

      return _react2.default.createElement(
        _Upload2.default,
        (0, _extends3.default)({}, uploadProps, { disabled: loading }),
        _react2.default.createElement(
          _Button2.default,
          { loading: loading },
          !loading && _react2.default.createElement(_Icon2.default, { type: props.triggerIcon }),
          props.triggerText
        ),
        props.listType === 'picture-card' && _react2.default.createElement('br', null),
        props.showTips && _react2.default.createElement(
          'span',
          { style: { color: "#999", fontSize: 12, marginLeft: 5 } },
          '\u4E0A\u4F20\u6587\u4EF6\u683C\u5F0F: ',
          props.accept.join(',')
        )
      );
    }
  }]);
  return SimpleUploader;
}(_react.PureComponent), _class.propTypes = {
  url: _propTypes2.default.string.isRequired
}, _temp);
exports.default = SimpleUploader;
module.exports = exports['default'];