# SkuCardList

传入一组sku信息，以商品卡片列表的形式进行展示。请结合 [FillPrice](/docs/ola-ui-jd/component/FillPrice) 组件使用。

## 示例

  <demo src="index.jsx" title="基础用法"></demo>

* 注：数据结构请参考示例, 该结构由后端未经加工输出。

## API

| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| skuList | 一组SKU信息列表,数据结构请参考demo | array | [] |
| loading | 价格加载状态 | boolean | true |
| errorMsg | 价格加载失败报错信息，会显示在价格位 | string | '' |

## 服务器端

### 配置

#### properties

为调用jsf服务配置别名，若别名失效，可在[JSF杰夫服务平台-测试环境](http://test.jsf.jd.com/)、
[JSF杰夫服务平台-线上环境](http://old.jsf.jd.com/)查询对应别名进行配置

##### 测试环境

```properties
crs.jsf.alias=lishuai
pop.vender.center.service.alias=popvendercenter
sns.jsf.alias=TEST
```

##### 线上环境

```properties
crs.jsf.alias=LF_PUBLIC
pop.vender.center.service.alias=popvendercenter
sns.jsf.alias=LF
```

#### xml

在spring配置文件中引入sku-service-jsf.xml即可声明sku服务类: SkuInfoService
 ```xml
<import resource="classpath:sku-service-jsf.xml"/>
```

### 添加http接口

#### 使用示例

使用预定义的bean: skuInfoService `(com.jd.ola.biz.service.sku.SkuInfoService)`

```java
@RestController
@RequestMapping("/sku")
public class SkuInfoController extends BaseController {

    @Resource
    private SkuInfoService skuInfoService;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public Result listSelective(@RequestParam("skuIds") String skuIds,
                                @RequestParam(value = "productFields", required = false) String productFields) {
        Result result = skuInfoService.getSkuInfoBatchSelective(
                Sets.newHashSet(skuIds.split(",")).stream().map(Long::parseLong).collect(Collectors.toSet()),
                productFields == null ? null : Sets.newHashSet(productFields.split(",")));
        return result;
    }
}
```

#### Controller参数说明

| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| skuIds | 一组SKU的ID组成的字符串，以","分隔 | string | 必须携带，否则无数据 |
| productFields | 一组SKU商品基本信息字段组成的字符串，以","分隔 | string | null |

productFields用于动态定义要返回的商品字段信息，详见[商品基本信息枚举值、特殊属性字段-ProductService-ProductBaseFieldEnum](https://cf.jd.com/pages/viewpage.action?pageId=59314641#id-【新】商品基本信息枚举值、特殊属性字段-ProductService-ProductBaseFieldEnum)

当productFields为null时，默认返回商品名称、商家编号和商品主图链接，即"NAME,VENDER_ID,IMAGE_PATH"
