'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _olaToolkit = require('ola-toolkit');

var _JfsImage = require('../JfsImage');

var _JfsImage2 = _interopRequireDefault(_JfsImage);

var _Spin = require('ola-ui/lib/components/Spin');

var _Spin2 = _interopRequireDefault(_Spin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
* Author: cdzhongpeizhi@jd.com
* Desc: 商品列表展示
* @props errorMsg: string  价格接口报错后，显示到价格位置的信息
* @props loading: boolean 价格接口loading 状态
* @props skuList: array sku信息列表
*/

var SkuCardList = function (_PureComponent) {
  (0, _inherits3.default)(SkuCardList, _PureComponent);

  function SkuCardList() {
    (0, _classCallCheck3.default)(this, SkuCardList);
    return (0, _possibleConstructorReturn3.default)(this, (SkuCardList.__proto__ || (0, _getPrototypeOf2.default)(SkuCardList)).apply(this, arguments));
  }

  (0, _createClass3.default)(SkuCardList, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          _props$skuList = _props.skuList,
          skuList = _props$skuList === undefined ? [] : _props$skuList,
          _props$loading = _props.loading,
          loading = _props$loading === undefined ? true : _props$loading,
          _props$errorMsg = _props.errorMsg,
          errorMsg = _props$errorMsg === undefined ? '' : _props$errorMsg;

      var styles = require('./style.less');

      return _react2.default.createElement(
        'div',
        null,
        skuList.length > 0 && _react2.default.createElement(
          'div',
          { className: styles.list },
          skuList.map(function (item, index) {
            return _react2.default.createElement(
              'a',
              { href: '//item.jd.com/' + item.skuId + '.html', target: '_blank', className: styles.card, key: index },
              _react2.default.createElement(
                'div',
                { className: styles.img },
                _react2.default.createElement(_JfsImage2.default, {
                  className: styles.pic,
                  space: 'club_community',
                  index: Math.round(Math.random() * 10),
                  src: item.imagePath })
              ),
              _react2.default.createElement(
                'div',
                { className: styles.price },
                !loading && errorMsg == '' && item.p < 0 ? '暂无报价' : item.p,
                !loading && errorMsg,
                loading && _react2.default.createElement(_Spin2.default, { size: 'small', style: { marginRight: 10 } })
              ),
              _react2.default.createElement(
                'div',
                { className: styles.name },
                item.name
              ),
              _react2.default.createElement(
                'div',
                { className: styles.evaluate },
                _react2.default.createElement(
                  'span',
                  null,
                  item.commentInfo.CommentCountStr
                ),
                ' \u6761\u8BC4\u4EF7'
              ),
              _react2.default.createElement(
                'div',
                { className: styles.shopName },
                item.isSelfVender ? '自营' : item.shopInfo.title
              )
            );
          })
        )
      );
    }
  }]);
  return SkuCardList;
}(_react.PureComponent);

exports.default = SkuCardList;
module.exports = exports['default'];