'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getOwnPropertyDescriptor = require('babel-runtime/core-js/object/get-own-property-descriptor');

var _getOwnPropertyDescriptor2 = _interopRequireDefault(_getOwnPropertyDescriptor);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _desc, _value, _class, _class2, _temp; /**
                                            * @since 2019-03-07
                                            * @author licunyan
                                            */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _olaToolkit = require('ola-toolkit');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

// import styles from './style.less'

var options = {
  content: 'ola',
  spaceX: 50,
  spaceY: 50,
  textAlign: 'center', //文本的中心被放在指定的位置（垂直）
  textBaseline: 'middle', // 文本基线是em方框的正中（水平）
  font: "20px microsoft yahei",
  fillStyle: 'rgba(184, 184, 184)', //属性设置或返回用于填充绘画的颜色，渐变和模式
  globalAlpha: 0.15, //透明度
  rotate: '-30', //旋转当前的绘图
  zIndex: 1000,
  sideX: 0,
  startY: 0
};

var Watermark = (_class = (_temp = _class2 = function (_PureComponent) {
  (0, _inherits3.default)(Watermark, _PureComponent);

  function Watermark(props) {
    (0, _classCallCheck3.default)(this, Watermark);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Watermark.__proto__ || (0, _getPrototypeOf2.default)(Watermark)).call(this, props));

    _this.state = {
      ops: (0, _assign2.default)({}, options),
      width: 0,
      height: 0
    };
    _this._modal = _react2.default.createRef();
    _this._container = _react2.default.createRef();
    return _this;
  }

  (0, _createClass3.default)(Watermark, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var angle = this.state.ops.rotate;

      angle = angle * (Math.PI / 180);
      var textWidth = this._modal.current.clientWidth;
      var textHeight = this._modal.current.clientHeight;
      var countWidth = Math.abs(Math.cos(angle)) * textWidth + Math.abs(Math.sin(angle)) * textHeight;
      var countHeight = Math.abs(Math.sin(angle)) * textWidth + Math.abs(Math.cos(angle)) * textHeight;
      this.setState({
        width: countWidth,
        height: countHeight
      }, function () {
        _this2.createUrl();
        _this2._modal.current.remove();
      });
    }

    //触发时间：每次获取新的props和state之后

  }, {
    key: 'createUrl',
    value: function createUrl() {
      var _state = this.state,
          _state$ops = _state.ops,
          content = _state$ops.content,
          textAlign = _state$ops.textAlign,
          textBaseline = _state$ops.textBaseline,
          font = _state$ops.font,
          fillStyle = _state$ops.fillStyle,
          rotate = _state$ops.rotate,
          zIndex = _state$ops.zIndex,
          globalAlpha = _state$ops.globalAlpha,
          spaceX = _state$ops.spaceX,
          spaceY = _state$ops.spaceY,
          sideX = _state$ops.sideX,
          startY = _state$ops.startY,
          width = _state.width,
          height = _state.height;


      var cnWidth = width + spaceX;
      var cnHeight = height + spaceY;
      var canvas = document.createElement('canvas');
      canvas.setAttribute('width', cnWidth);
      canvas.setAttribute('height', cnHeight);

      var ctx = canvas.getContext("2d");
      ctx.textAlign = textAlign;
      ctx.textBaseline = textBaseline;
      ctx.font = font;
      ctx.fillStyle = fillStyle;
      ctx.globalAlpha = globalAlpha;
      //中心旋转方法：1、把旋转中心移动到画布中心；2、旋转完后再把旋转中心移回去
      ctx.translate(cnWidth / 2, cnHeight / 2);
      ctx.rotate(Math.PI / 180 * rotate);
      ctx.translate(-cnWidth / 2, -cnHeight / 2);
      //在画布上绘制填色文本，context.fillText(text,x,y,maxWidth);
      if (width !== 0) {
        ctx.fillText(content, parseFloat(cnWidth) / 2, parseFloat(cnHeight) / 2);
      }

      var base64Url = canvas.toDataURL();
      var watermarkDiv = this._container.current;

      var styleStr = '\n          position:absolute;\n          top:0;\n          left:0;\n          width:100%;\n          height:100%;\n          margin-left:' + sideX + 'px;\n          margin-right:' + sideX + 'px;\n          padding-top:' + startY + 'px;\n          z-index:' + zIndex + ';\n          pointer-events:none;\n          background-repeat:repeat;\n          background-image:url(\'' + base64Url + '\');\n          ';

      watermarkDiv.setAttribute('style', styleStr);

      //  const MutationObserver = window.MutationObserver || window.WebKitMutationObserver;
      //  if(MutationObserver){
      //    let mo = new MutationObserver(function () {
      //      // 只在__wm元素变动才重新调用 createUrl()
      //      if(watermarkDiv && watermarkDiv.getAttribute('style') != styleStr || !watermarkDiv){
      //         // 避免一直触发
      //        mo.disconnect();
      //        mo = null
      //        this.createUrl()
      //      }
      //    })

      //   mo.observe(document.querySelector('.watermark'), {
      //     attributes: true,
      //     subtree: true,
      //     childList: true
      //   })
      //  }
    }
  }, {
    key: 'render',
    value: function render() {
      var content = this.state.ops.content;


      return _react2.default.createElement(
        'div',
        {
          style: { position: "relative" },
          ref: this._element,
          className: 'watermark'
        },
        this.props.children,
        _react2.default.createElement('div', { ref: this._container }),
        _react2.default.createElement(
          'div',
          { ref: this._modal, style: {
              whiteSpace: 'nowrap', //文本不换行
              font: "20px microsoft yahei",
              display: "inline-block",
              opacity: 0
            } },
          content
        )
      );
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, state) {
      var ops = state.ops;

      ops = (0, _assign2.default)({}, ops, props);

      return {
        ops: ops
      };
    }
  }]);
  return Watermark;
}(_react.PureComponent), _class2.propTypes = {
  children: _propTypes2.default.node,
  spaceX: _propTypes2.default.number,
  spaceY: _propTypes2.default.number,
  rotate: _propTypes2.default.number,
  globalAlpha: _propTypes2.default.number,
  font: _propTypes2.default.string,
  content: _propTypes2.default.string,
  fillStyle: _propTypes2.default.string,
  sideX: _propTypes2.default.number,
  startY: _propTypes2.default.number
}, _temp), (_applyDecoratedDescriptor(_class.prototype, 'createUrl', [_olaToolkit.bind], (0, _getOwnPropertyDescriptor2.default)(_class.prototype, 'createUrl'), _class.prototype)), _class);
exports.default = Watermark;
module.exports = exports['default'];